traceroute: fix help text to not show -6 when traceroute6 is off
[oweals/busybox.git] / scripts / trylink
index 89e36b7e9608a1a38518aa128521248eed867c3e..8c8854679be80d0294ebb3e807c3a446a1fa8933 100755 (executable)
@@ -41,9 +41,8 @@ try() {
     printf "%s\n" "$*" >>$EXE.out
     printf "%s\n" "==========" >>$EXE.out
     $debug && echo "Trying: $*"
-    "$@" >>$EXE.out 2>&1
-    exitcode=$?
-    return $exitcode
+    $@ >>$EXE.out 2>&1
+    return $?
 }
 
 check_cc() {
@@ -66,7 +65,7 @@ check_libc_is_glibc() {
        #if defined(__GLIBC__) && !defined(__UCLIBC__)
        syntax error here
        #endif
-       " >"$tempname"
+       " >"$tempname".c
     if $CC "$tempname".c -c -o "$tempname".o >/dev/null 2>&1; then
        echo "$2";
     else
@@ -83,15 +82,15 @@ O_FILES="$5"
 A_FILES="$6"
 LDLIBS="$7"
 
-# The -Wl,--sort-section option is not supported by older versions of ld
-SORT_SECTION=`check_cc "-Wl,--sort-section -Wl,alignment" ""`
+# The --sort-section option is not supported by older versions of ld
+SORT_SECTION=`check_cc "-Wl,--sort-section,alignment" ""`
 
 # Static linking against glibc produces buggy executables
 # (glibc does not cope well with ld --gc-sections).
 # See sources.redhat.com/bugzilla/show_bug.cgi?id=3400
 # Note that glibc is unsuitable for static linking anyway.
 # We are removing -Wl,--gc-sections from link command line.
-GC_SECTION=`(
+GC_SECTIONS=`(
 . ./.config
 if test x"$CONFIG_STATIC" = x"y"; then
     check_libc_is_glibc "" "-Wl,--gc-sections"
@@ -100,6 +99,11 @@ else
 fi
 )`
 
+# The --gc-sections option is not supported by older versions of ld
+if test -n "$GC_SECTIONS"; then
+    GC_SECTIONS=`check_cc "$GC_SECTIONS" ""`
+fi
+
 # Sanitize lib list (dups, extra spaces etc)
 LDLIBS=`echo "$LDLIBS" | xargs -n1 | sort | uniq | xargs`
 
@@ -112,7 +116,7 @@ try $CC $CFLAGS $LDFLAGS \
        -o $EXE \
        -Wl,--sort-common \
        $SORT_SECTION \
-       $GC_SECTION \
+       $GC_SECTIONS \
        -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
        $l_list \
 || {
@@ -126,33 +130,37 @@ try $CC $CFLAGS $LDFLAGS \
 while test "$LDLIBS"; do
     $debug && echo "Trying libraries: $LDLIBS"
     all_needed=true
+    last_needed=false
     for one in $LDLIBS; do
        without_one=`echo " $LDLIBS " | sed "s/ $one / /g" | xargs`
        # "lib1 lib2 lib3" -> "-llib1 -llib2 -llib3"
        l_list=`echo "$without_one" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
-       test "x$l_list" != "x" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
+       test x"$l_list" != x"" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
        $debug && echo "Trying -l options: '$l_list'"
        try $CC $CFLAGS $LDFLAGS \
                -o $EXE \
                -Wl,--sort-common \
                $SORT_SECTION \
-               $GC_SECTION \
+               $GC_SECTIONS \
                -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
                $l_list
        if test $? = 0; then
-           echo " Library $one is not needed"
+           echo " Library $one is not needed, excluding it"
            LDLIBS="$without_one"
            all_needed=false
+           last_needed=false
        else
-           echo " Library $one is needed"
+           echo " Library $one is needed, can't exclude it (yet)"
+           last_needed=true
        fi
     done
     # All libs were needed, can't remove any
     $all_needed && break
-    # If there is no space char, the list has just one lib.
-    # I'm not sure that in this case lib really is 100% needed.
-    # Let's try linking without it anyway... thus commented out.
-    #{ echo "$LDLIBS" | grep -q ' '; } || break
+    # Optimization: was the last tried lib needed?
+    if $last_needed; then
+       # Was it the only one lib left? Don't test again then.
+       { echo "$LDLIBS" | grep -q ' '; } || break
+    fi
 done
 
 # Make the binary with final, minimal list of libs
@@ -165,11 +173,11 @@ if ! test -f busybox_ldscript; then
            -o $EXE \
            -Wl,--sort-common \
            $SORT_SECTION \
-           $GC_SECTION \
+           $GC_SECTIONS \
            -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
            $l_list \
            -Wl,--warn-common \
-           -Wl,-Map -Wl,$EXE.map \
+           -Wl,-Map,$EXE.map \
            -Wl,--verbose \
     || {
        cat $EXE.out
@@ -187,12 +195,12 @@ else
            -o $EXE \
            -Wl,--sort-common \
            $SORT_SECTION \
-           $GC_SECTION \
-           -Wl,-T -Wl,busybox_ldscript \
+           $GC_SECTIONS \
+           -Wl,-T,busybox_ldscript \
            -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
            $l_list \
            -Wl,--warn-common \
-           -Wl,-Map -Wl,$EXE.map \
+           -Wl,-Map,$EXE.map \
            -Wl,--verbose \
     || {
        cat $EXE.out
@@ -225,7 +233,7 @@ if test "$CONFIG_BUILD_LIBBUSYBOX" = y; then
            -Wl,--start-group $A_FILES -Wl,--end-group \
            $l_list \
            -Wl,--warn-common \
-           -Wl,-Map -Wl,$EXE.map \
+           -Wl,-Map,$EXE.map \
            -Wl,--verbose \
     || {
        echo "Linking $EXE failed"
@@ -243,11 +251,11 @@ if test "$CONFIG_FEATURE_SHARED_BUSYBOX" = y; then
            -o $EXE \
            -Wl,--sort-common \
            $SORT_SECTION \
-           $GC_SECTION \
+           $GC_SECTIONS \
            -Wl,--start-group $O_FILES -Wl,--end-group \
            -L"$sharedlib_dir" -lbusybox \
            -Wl,--warn-common \
-           -Wl,-Map -Wl,$EXE.map \
+           -Wl,-Map,$EXE.map \
            -Wl,--verbose \
     || {
        echo "Linking $EXE failed"
@@ -282,7 +290,7 @@ int main(int argc, char **argv)
                -o $EXE \
                -Wl,--sort-common \
                $SORT_SECTION \
-               $GC_SECTION \
+               $GC_SECTIONS \
                -L"$sharedlib_dir" -lbusybox \
                -Wl,--warn-common \
        || {